// PROJECT  :ExternalInterrupt7Segment
// PURPOSE  :User manipulation of a 7-segment display through the use of External Interrupts (INT0 and INT1)
// COURSE   :ICS4U
// AUTHOR   :C. D'Arcy
// DATE     :2022 01 06
// MCU      :328P
// STATUS   :Working
// REFERENCE:http://darcy.rsgc.on.ca/ACES/Datasheets/ATMEGA328P.pdf

#include <Mega328P.h>               // personal library

//uint8_t digits[] = {};            // LED Segment LUT if driving directly
//uint8_t numDigits = sizeof(digits);
uint8_t numDigits = 10;             // if using the 4511 BCD Decoder

int8_t digit = 0;                   // variable manipulated by external interrupts INT0 and INT1
volatile boolean extInt0 = false;
volatile boolean extInt1 = false;

void setup() {
  Serial.begin(9600);   // if necessary...
  while (!Serial);

  extIntSetup();        // prepare INT0 and INT1 for use
  displaySetup();       // prepare digital IO pins for 7-Segment use
  showDigit(digit);     // present a value to start
}

void extIntSetup() {
  // select the preferred 'edge sense'...
  EICRA |= 0;
  // enable the two external interrupts...
  EIMSK |= 0;
  // clear the two interrupt flags...
  EIFR |= 0;
}

ISR(INT0_vect) {
  //respond in your preferred way to an INT0 event
}


ISR(INT1_vect) {
  //respond in your preferred way to an INT1 event
}

void displaySetup() {
  // set your 7-segment digital IO pins to output
}

void showDigit(uint8_t d) {
}


void loop() {
  if (extInt0) {         // ?
  }
  if (extInt1) {
  }
}
